#ifndef COIL_SEGMENT_HPP
#define COIL_SEGMENT_HPP

#include <cstdint>

class Coil;

class CoilSegment {
    Coil *coil;
    uint16_t year;
    uint16_t height;
    // Number of a segments, counting from the central (which is 0)
    int shift;
    uint32_t sliceDetalization;
    bool isLeap;
    float *vertices;
    uint64_t verticesLength;

    void init();
    float* calculateSlice();
    void constructSegment(float *slice);

    public:
    CoilSegment(Coil* coil, uint16_t year, uint16_t height, int shift, uint32_t sliceDetalization, bool isLeap);
    void calculate();
    void printVertices();
    float *getVertices();
    uint64_t getVerticesLength();
    void printSlice(float *slice);
    void exportSliceToCSV(float *slice);
    void exportSegmentToCsv();
    void render();
    void fillVBO();
    uint64_t fillEBO(uint64_t EBO);
    uint16_t getYear();
};

#endif // COIL_SEGMENT_HPP